variables:
  DOCKER_TLS_CERTDIR: ''
#   DOCKER_HOST: $NEXUS_URL

stages:
  - build
  - reportsGeneration
  - reportsDeployment
  - publish

.gradle_context: &gradle_context
  image: gradle:7.5.1-jdk17-alpine
  before_script:
    - GRADLE_USER_HOME="$(pwd)/.gradle"
    - export GRADLE_USER_HOME
  cache:
    key: "$CI_PIPELINE_IID"
    paths:
      - build/
      - "$CI_PROJECT_NAME/build/"
      - "$CI_PROJECT_NAME-starter/build/"
      - .gradle

# --=-=-=-=-= stage: build =-=-=-=-=-==-=-
build:
  <<: *gradle_context
  stage: build
  script:
    - gradle build --build-cache -I=$GRADLE_INIT_FILE
  only:
    - master
    - develop


# --=-=-=-=-= stage: build =-=-=-=-=-==-=-
build-manual:
  image: gradle:7.5.1-jdk17-alpine
  before_script:
    - GRADLE_USER_HOME="$(pwd)/.gradle"
    - export GRADLE_USER_HOME
  stage: build
  when: manual
  script:
    - gradle build -I=$GRADLE_INIT_FILE
  only:
    - master
    - develop

# --=-=-=-=-= stage: reportsGeneration =-=-=-=-=-==-=-
sonarqube-check:
  <<: *gradle_context
  stage: reportsGeneration
  needs: ["build"]
  variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
    GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script: gradle jacocoTestReport sonar --build-cache -I=$GRADLE_INIT_FILE
  allow_failure: true
  only:
    - master

.set_archive_name: &set_archive_name
  - export ARCHIVE_NAME=test-report_$CI_PROJECT_NAME+$REPORT_NAME+$CI_COMMIT_REF_NAME+$CI_COMMIT_SHORT_SHA.tar.bz2

# send to nexus
# code générique, variable à définir: $REPORT_NAME, $FOLDER_TO_ARCHIVE, $ARCHIVE_NAME
.send_archive: &send_archive
  - cd $FOLDER_TO_ARCHIVE
  - tar jcvf $ARCHIVE_NAME ./
  - 'curl -u $NEXUS_USER:$NEXUS_PASSWORD --upload-file $ARCHIVE_NAME $NEXUS_BAC_FOLDER/test-reports/$ARCHIVE_NAME'

generate_test_report_cucumber:
  <<: *gradle_context
  stage: reportsGeneration
  needs: ["build"]
  script:
    # report is already generated. it's in the cache
    # send to nexus
    - apk update; apk upgrade;
    - apk add curl
    - export REPORT_NAME=cucumber
    - export FOLDER_TO_ARCHIVE=$CI_PROJECT_NAME/build/cucumber
    - mv $CI_PROJECT_NAME/build/cucumber/report.html $CI_PROJECT_NAME/build/cucumber/index.html
    - *set_archive_name
    - *send_archive
  only:
    - master
    - develop

# --=-=-=-=-= stage: reportsDeployment =-=-=-=-=-==-=-

# déploie l'archive vers bac-test-reports.kisdev.altereo.fr/$CI_PROJECT_NAME/$CI_COMMIT_REF_NAME/$REPORT_NAME
# send the test report to a volume mounted on the pod $NGINX_TEST_REPORTS_POD
# code générique, variable à définir: $REPORT_NAME, $ARCHIVE_NAME
.deploy_report: &deploy_report
  - kubectl config use-context $CI_CONTEXT_DEV
  - apk add curl
  - 'curl -k -u $NEXUS_USER:$NEXUS_PASSWORD -o $ARCHIVE_NAME $NEXUS_BAC_FOLDER/test-reports/$ARCHIVE_NAME'
  - mkdir -p folderTemp/$REPORT_NAME
  - tar xvf $ARCHIVE_NAME -C folderTemp/$REPORT_NAME
  - ls -la folderTemp/$REPORT_NAME
  - export NGINX_TEST_REPORTS_POD=$(kubectl get pods -n kis-dev | grep bac-test-reports | awk '{print $1}')
  - echo $NGINX_TEST_REPORTS_POD
  - echo "kubectl exec -n kis-dev $NGINX_TEST_REPORTS_POD -- sh -c 'mkdir -p /usr/src/app/test-reports/$CI_PROJECT_NAME/$CI_COMMIT_REF_NAME'" | envsubst | sh
  - echo "kubectl exec -n kis-dev $NGINX_TEST_REPORTS_POD -- sh -c 'rm -rf /usr/src/app/test-reports/$CI_PROJECT_NAME/$CI_COMMIT_REF_NAME/$REPORT_NAME'" | envsubst | sh
  - kubectl cp -n kis-dev folderTemp/$REPORT_NAME $NGINX_TEST_REPORTS_POD:/usr/src/app/test-reports/$CI_PROJECT_NAME/$CI_COMMIT_REF_NAME/
  - echo report has been deployed on bac-test-reports.kisdev.altereo.fr/$CI_PROJECT_NAME/$CI_COMMIT_REF_NAME/$REPORT_NAME

deploy_test_report_cucumber:
  image: qtzzz/kubectl-alpine:1.1
  stage: reportsDeployment
  needs: ["generate_test_report_cucumber"]
  environment:
    name: dev
  script:
    - export REPORT_NAME=cucumber
    - *set_archive_name
    - *deploy_report
  only:
    - master
    - develop

# --=-=-=-=-= stage: publish =-=-=-=-=-==-=-
publish_to_nexus:
  <<: *gradle_context
  stage: publish
  needs: ["build"]
  when: manual
  only:
    - master
  script:
    - gradle publish --build-cache -I=$GRADLE_INIT_FILE
